TODO: 
 * Process times and similar ?
 * Fix configuration GUI (low priority)
 * Add API for rehashing the daemon (or implement it the API is there but does nothing)
 * Improved socket performance (would be nice if we could be used as a "hub")
 * Fix depend onservice LanManWorkStation (old win)
 * Fix RtlStringFromGUID problem on NT4

2010-05-25 MickeM - 0.3.8 (take 3)
 ! Release the new version
 * Fixed issue with CheckServiceState

2010-05-25 MickeM - 0.3.8 (take 2)
 ! Release the new version
 * Fixed issue with FILEAGE

2010-05-19 MickeM - 0.3.8
 ! Release the new version

2010-05-17 MickeM
 * Fixed id is considerd an int (not a string) in the eventlog filter
 
2010-05-14 MickeM
 * Fixed issue with LUA script module not using relative path
 * New default syntax for CheckEventLog

2010-05-12 MickeM - 0.3.8 RC3
 * Fixed issue which caused latest build to crash

2010-05-10 MickeM - 0.3.8 RC2
 * Fixed issue with listpdh and debugpdh (not works again)
 + Fixed issue and added support for IN ( ... ) and NOT IN ( ... ) operators (CheckEventLog)

2010-05-08 MickeM
 + Added new "script templating" thing to simplify adding scripts:
   Two new sections: [Script Wrappings] for adding templates and [Wrapped Scripts] for adding the scripts.
    %SCRIPT% is replaced with the script name
    %ARGS% is replaced with arguments.
     vbs=cscript.exe //T:30 //NoLogo scripts\wrapper.vbs %SCRIPT% %ARGS%
    and
     w_vbs=check_test.vbs /arg1:1 /arg2:1 /variable:1
    is the same as:
     w_vbs=cscript.exe //T:30 //NoLogo scripts\wrapper.vbs check_test.vbs /arg1:1 /arg2:1 /variable:1
 * Added correct syntax for VB scripts
 * Added correct syntax for powershell scripts
 * Cleaned up scripts folder
 + Added new "NagiosPlugin library" from op5
 + Added check_no_rdp.vbs (Checks that no RDP connection is online)
 + Added check_battery.vbs which checks batterys via WMI
 + Added check_printer.vbs to check printers via WMI

2010-04-21 MickeM - 0.3.8 RC1
 + Added support for strings and int (values) to CheckSingleRegEntry
   Use like so (int):
    CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSize "syntax=%path%: %int%"  warn==20971520 crit==20971520 check=int ShowAll=long
    CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSize "syntax=%path%: %int%"  warn==30971520 crit==30971520 check=int ShowAll=long
   Use like so (string):
    CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSize "syntax=%path%: %string%"  warn==20971520 crit==20971520 check=string ShowAll=long
    CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSize "syntax=%path%: %string%"  warn==30971520 crit==30971520 check=string ShowAll=long
   This can ofcourse be combined and all valid operators (like regexp, substr, lt, gt, ne etc etc are supported.
   
2010-04-16 MickeM
 + Added new Check to CheckSystem: CheckSingleRegEntry
   Similar to the previous CheckSIngleFile but can be used to check aspects of registry entries.
     CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSize "syntax=%path%: %exists%"  warn==true crit==true check=exists ShowAll=long
	 CheckSingleRegEntry path=HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\eventlog\Application\MaxSizeYY "syntax=%path%: %exists%"  warn==true crit==true check=exists ShowAll=long
   Currently only supports checking existanse of keys but more checks will be added soon.

2010-04-14 MickeM
 ! Fixed erroneous error message "Failed to peek buffer"
 
2010-04-13 MickeM
 + Added support for dates in the new CheckEventLog so the following are equvivalent:
    CheckEventLog debug=true file=application file=system MaxWarn=1 MaxCrit=1 "filter=generated gt -2d AND severity = 'error'" truncate=800 unique descriptions "syntax=%severity%: %source%: %strings% (%count%)"
    CheckEventLog debug=true file=application file=system filter=new filter=in MaxWarn=1 MaxCrit=1 filter+generated=gt:2d filter+severity==error truncate=800 unique descriptions "syntax=%severity%: %source%: %strings% (%count%)" debug-threshold=100

2010-04-09 MickeM
 + Added "like" keyword to comapre strings like so:
    "filter=severity = 'error' AND strings like 'SQLEXPRESS'"
    CheckEventLog debug=true file=application file=system MaxWarn=1 MaxCrit=1 "filter=severity = 'error' AND strings like 'SQLEXPRESS'" truncate=800 unique descriptions "syntax=%severity%: %source%: %strings% (%count%)"
 * Fixed eventlog check issue (Reverted "major eventlog change" since it did in fact break to many things)

2010-04-04 MickeM
 - Reverted "major eventlog change" since it did in fact break to many things
 + Added new major addition to CheckEventLog
   CheckEventLog has a compleatly new syntax borrowed from SQL.
   CheckEventLog MaxWarn=1 MaxCrit=1 "filter=(id = 123 OR id = 321) AND (severity='warning' OR severity='error')"
   Avalible operators are: =, !=, >, <, >=, <=, eq, ne, gt, lt, ge, le, OR, AND
   Avalible functions are: convert(<value>) (will try to automatically convert type)
   Avalible variables are: severity (others may work but this will come in the next week)

2010-03-24 MickeM
 + added a new "option" in conjunction with -c you can now do -m to specify the module to load.
   nsclient++ -m CheckDisk.dll -c CheckDriveSize MaxWarn=100 CheckAll
   This prevents socket based modules from loading causing "bind" errors.

2010-03-11 MickeM
 * Fixed MAJOR issue with CheckEventLog and this might actually break "existing" checks so let me know.
   Problem was I matched filter+ incorrectly.
 + Added new option debug-threshold to set "after which rule" we will start dumping filter matches (very usefull to ignore first rule)
   CheckEventLog debug=true debug-threshold=1 (will be alot more usefull then without the threshold)

2010-03-08 MickeM
 + Added new option append-filter-<key>=<value> to CheckEventLog to allow "and" of filter rules.
   CheckEventLog file=application file=system filter=out MaxWarn=1 MaxCrit=1 filter-eventID=ne:1 filter-eventID=eq:1 append-filter-eventSource==SecurityCenter truncate=1023 unique descriptions "syntax=%source%: %id% (%count%)"
 + Added debug option to CheckEventLog (to allow settingdebug on per-check)
 + Added obfuscated_password to NSCA section
 + Added so "global" ([Settings] password=...) passwords are read from the NSCA module
 
2010-02-26 MickeM
 * Changed so missing files and such generate an error
 * Added option to return error messages to the client [CheckDisk] show_errors=1 (defauilt is off 0)
 * Added warning message ewhen numerical filters evaluate to zero (and are not 0)
 * Fixed major issue with date mathing in CheckFile* which was not working at all.

2010-01-24 MickeM
 * Fixed so files locked for reading can be chcked (basic checks)
 * Improved speed of file chyecking (does not check file data twice)

2010-01-23 MickeM
 + Added checks for missing path and missing filter on CheckFile2 thus
    CheckFile2 without paths and/or filters will have status unknown.
 * Changed "missing" disks are now a critical error and not unknown
 * Improved CheckDriveSize bad FilterType error message
 + Added checks for missing counters to CheckCounter
 + Added new thread safe PDH subsystem (switch using the new option pdh_subsystem=thread-safe (normal mode is fast).
   The reason for this new subsystem is to allow reloading counters and get around some quirks in various PDH implementations (mainly HP)
   Added benefits of this new mode is that you can now reload counters which are changed during runtime.
   This is done by adding the reload flag to the CheckCounter command.
   THIS IS AN ADVANCED FEATURE (so dont use unless you know what you are doing)
 + Added new index option to CheckCounter to allow looking up index and thus you can use the same checks on multiple locales and also use characters not present in "NRPE charset)
    CheckCounter index "Counter=\1450(_Total)\1458" ShowAll MaxWarn=500 MaxCrit=1000
   same as
    CheckCounter "Counter=\\Utskriftskö(_Total)\\Utskrifter" ShowAll MaxWarn=500 MaxCrit=1000
   To find index you can use the command line options:
    nsclient++ -noboot CheckSystem pdhlookup Utskrifter

2009-12-31 MickeM
 * Fixed CheckFile* time handling so it is "signed"
   This means you can check for "future dates" as well as future dates works correctly:
   Like so:
    CheckFile2 debug path=D:\tmp\dates filter+creation=>30m MaxWarn=1 MaxCrit=1 "syntax=%filename%: %creation%"
    CRITICAL:past.txt: Thursday, December 31, 2009 08:47:30, found files: 1 > critical|'found files'=1;1;1;
    CheckFile2 debug path=D:\tmp\dates filter+creation=<-30m MaxWarn=1 MaxCrit=1 "syntax=%filename%: %creation%"
    CRITICAL:future.txt: C: Thursday, December 31, 2009 12:47:11, found files: 1 > critical|'found files'=1;1;1;
 + Added volume support for CheckDriveSize (CHeckAll) like so:
   Like so:
    CheckDriveSize MinWarn=50% MinCrit=25% CheckAll=volumes FilterType=FIXED FilterType=REMOTE
 + Added %user% to syntax to print user who generated message.
   Like so:
    CheckEventLog file=application file=system filter=new filter=out MaxWarn=1 MaxCrit=1 filter-generated=>2w filter-severity==success filter-severity==informational truncate=1023 unique descriptions "syntax=%user% (%count%)"
    CRITICAL: (1),  (2), NT INSTANS\SYSTEM (3), NT INSTANS\SYSTEM (3), NT INSTANS\SYSTEM (3), missing (3), missing (5),  (4), missing (2), missing (2), missing (2), missing (2),  (1), eventlog: 33 > critical|'eventlog'=33;1;1;

2009-12-21 MickeM
 ! BREAKING CHANGE!
 ! New perfoamcen data syntax for ALL % checks
   Alias is '<alias> %' and it also has the "full" non % data as '<alias>'
   Like so:
	CheckDriveSize CheckAll MaxWarnUsed=80% MaxCritUsed=90%
	CRITICAL:CRITICAL: C:\: Total: 146G - Used: 140G (95%) - Free: 6.31G (5%) > critical, D:\: Total: 152G - Used: 148G (97%) - Free: 3.59G (3%) > critical|'C:\ %'=95%;80;90; 'C:\'=140.17G;117.18;131.83;0;146.48; 'D:\ %'=97%;80;90; 'D:\'=147.93G;121.21;136.3;0;151.52;
	CheckDriveSize CheckAll MaxWarnFree=20% MaxCritFree=10%
	OK:OK: All drives within bounds.|'C:\ %'=5%;20;10; 'C:\'=140.17G;29.29;14.64;0;146.48; 'D:\ %'=3%;20;10; 'D:\'=147.93G;30.30;15.15;0;151.52;
	CheckDriveSize CheckAll MaxWarnUsed=100G MaxCritUsed=150G
	WARNING:WARNING: C:\: Total: 146G - Used: 140G (95%) - Free: 6.31G (5%) > warning, D:\: Total: 152G - Used: 148G (97%) - Free: 3.59G (3%) > warning|'C:\ %'=95%;32;4294967294; 'C:\'=140.17G;100;150;0;146.48; 'D:\ %'=97%;35;2; 'D:\'=147.93G;100;150;0;151.52;
	CheckDriveSize CheckAll MaxWarnFree=20G MaxCritFree=10G
	OK:OK: All drives within bounds.|'C:\ %'=5%;87;94; 'C:\'=140.17G;20;10;0;146.48; 'D:\ %'=3%;87;94; 'D:\'=147.93G;20;10;0;151.52;

2009-12-13 MickeM
 + Added new command: CheckSingleFile to check spects of a single file use like so:
   CheckSingleFile file=d:\nrpe_512.pem warn=>100 check=line-count warn=>100 crit=>170 check=size
 + Added option debug to CheckFile2 to enable priting of debug information
 + Added ignore-errors to "ignore" any filesystem related errors (NOTICE this is probably not what you want)
 + Added master-syntax to CheckFile2 to change the overall message like so:
    It takes three options (and char data):
     * %list% A list of all "files" (syntax controls this)
     * %files% number of files
     * %matches% number of files matched
    CheckFile2 MinWarn=10 MinCrit=10 path=D:\WINDOWS\system32 filter+size=gt:0 truncate=10 ignore-errors "master-syntax=%matches%/%files%"
    OK:7177/7...|'found files'=7177;10;10;

2009-12-06 MickeM
 + Added != to all string filters
 + Sorted out the alias handling it is now wither what you specify or "files found" (this makes performance data work)
 + Added version to CheckFile2
   CheckFile2 path=D:\tmp pattern=*.exe filter+version=!=1.0 "syntax=%filename%: %version%" MaxWarn=1
   CheckFile2 path=D:\tmp pattern=*.exe filter+version=!=6.0.2900.5512 "syntax=%filename%: %version%" MaxWarn=1
 + Added line count to CheckFile2 to count lines
   CheckFile2 path=D:\tmp pattern=*.txt filter+line-count=!=2 "syntax=%filename%: %line-count%" MaxWarn=1
   CheckFile2 path=D:\tmp pattern=*.txt filter+line-count=ne:3 "syntax=%filename%: %line-count%" MaxWarn=1

2009-xx-x MickeM - 0.3.7
 ! Release the new version

2009-10-11 MickeM
 + Added argument support to NRPE Client
   This is temporarily enabled by the same options under the NRPE section. BUT this will change int he future so be ware when using them.

2009-09-20 MickeM
 * Fixed alias in CheckWMI (now works)
 + Added columnSyntax to CheckWMI to allow formating of returned data (default is %column%=%value%)
 + Added columnSeparator to CheckWMI to allow formating of returned data (default is ", ")

2009-09-13 MickeM
 * Fixed some more issues with the installer should not "work" on Windows 2008 as well as slightly simpler to configure.

2009-09-06 MickeM
 + Added new option to [NSCA Agent] string_length=<size> of the NSCA_MAX_PLUGINOUTPUT_LENGTH option on the NSCA server.
 * Readded all the "installer configuration" crap which I accidentaly removed when I fixed the installer... *sigh*

2009-08-30 MickeM
 + Added -c and -d command line options like so:
   NSClient++ -c CheckFile2 path=c:\test pattern=*.txt MaxCrit=1 filter+written=gt:2h
   NSClient++ -c <command> <argument 1> <argument 2> ...
   -d Is the same thing but with debug enabled.
 + Added uninstall of old client (sort of broken but works)

2009-08-29 MickeM
 * Fixed issue with CheckFile (directory)
 * Rewrote the CA:s in the installer to work "better" (hopefully) in general it should be have more like a propper installer.

2009-07-18 MickeM
 * Fixed issue with no loggers avalible and "memory leak"
 * Added "firewall exception" to installer
 * Fixed an issue with the socket data buffer
 * Added new option to NSC.ini [NSCA] socket_timeout=30 (timeout in seconds when reading from NSCA sockets)
 * Fixed issue with NSCA socket.

2009-07-05 MickeM
 * Fixed issue with CheckExternalScripts and script_dir: not adding the commands properly.
 * Fixed issue with CheckExternalScripts and script_dir: not using relative paths (#310).

2009-06-20 MickeM
 * Fixed issue with CheckDisk and paths not working out properly

2009-06-10 MickeM - 0.3.6
 ! Release the new version

2009-06-10 MickeM 
 * Fixed so CheckEventLog only reports invalid buffersizes once

2009-06-07 MickeM 
 * Fixed issue with CheckFileAge incorrectly working in recursive mode.
 * Finalized the installer

2009-05-22 MickeM 
 * Fixed time_delay option in NSCA config (now uses the correct base was 1000 times to large before)

2009-05-21 MickeM 
 * Fixed issue with eventlog parsing and 64 bit machines (descriptions option)
 * Fixed issue with "modern windows" and installing the service (should not have the correct privlaiges)

2009-05-17 MickeM 
 * Changed default buffer size for process enumeration (64K now instead of 1K should I hope work better on 64bit OS:es)

2009-05-10 MickeM 
 + Added write support for modules to installer

2009-05-03 MickeM 
 * Fixed another quite serious memory leak!
   And this was a hard one, took me hours and hours and hours (read weeks) to track down, but here we are!
 * A lot of other fixes as I have been through much of the code looking for the memmory leak above.

2009-03-30 MickeM 
 + Added new option to NSCA module for specifying report options.
	report=all (report=warning,critical) etc etc to specify which kind of return datat to get default value is all.
 + Added so password and host ate stored in the installer (if changed)

2009-03-29 MickeM 
 * Fixed a lot of issues with the installer and added a start on exit (and donate) on the finnish dialog.

2009-03-15 MickeM 
 * New service name (displayname)
 * New service description

2009-03-14 MickeM 
 * Rebuilt installer UI (still missing write config function)
 * Added debug entry to log filename used by debug log metrics.
 * Fixed so alias will not require the allow_nasty_metachars option set under external sripts module.

2009-03-02 MickeM 
 * Added catch handlers and error logging to NSCA Thread
 * Fixed issue with CheckProcState and administrator login!
 + Added debug module to installer
 + Added option max-dir-depth to CheckFile and CheckFile2 like so:
   CheckFile "file=c:\test\*.txt" filter-size=<24g "syntax=%filename%: %size%" MaxCrit=1 max-dir-depth=0
   Will only find files on the "first level" where as max-dir-depth=1 would find all parents and children etc. (-1 is the default and means find all)
 * Fixed issue with finding sub-folders and *.txt now it will always look for subfolders if they are present

2009-02-26 MickeM 
 * Fixed issue with debug logging (not it can be disabled again)

2009-02-23 MickeM 
 * Fixed build issues so NSCA now has all cryuptos avalible (verify with nsclient++ /about)

2009-02-11 MickeM 
 * Fixed so that performance data is always(?) renderd regardless of if we have bounds or not.
   This was primarily to fix issues where we have might not "unexpectedly" get performance data (might still be some issues here so let me know).

2009-02-06 MickeM 
 * Fixed so that arguments ($ARG1$) are parsed properly for alias in CheckExternalScript

2009-02-05 MickeM 
 * Fixed so the error message for "to small eventlog buffer" specifies the required size.
 * Changed so that event log buffer problems are "ignored in the result" (still logged in the error log).

2009-02-03 MickeM 
 * Added support for changing the time when using NSCA with the time_delay in NSC.ini
   time_delay=+4h or time_delay=-1h etc should can now be used when system time not the same as NSCA time.

2009-01-30 MickeM 
 * Added support for changing name and description of service from the /install command line
   NSClient++ /install [gui] [start] [service name] [description]
   NSClient++ /uninstall [gui] [stop] [service name]
   NSClient++ /start [gui] [service name]
   NSClient++ /stop [gui] [service name]

2009-01-28 MickeM 
 * Slightly improved error handling around socket creation
 * Fixed some pretty minor issues with the SysTray module (uncreation as well as new boost build).

2009-01-25 MickeM 
 * Fixed issue with checkVersion (#242)
 * Fixed spelling error (#244)
 * Fixed crash in CheckFile when a file was locked in exclusive mode (#254)
 + Improved error handling in all CheckDIsk/CheckFile checks. Should report errors better now.
 * Updated the config file a bit: remving "beta" from a bunch of modules no longer in beta.  (#270)
 + Added more filter operatos to all numeric filters so they accept eq:, ne:, gt:, lt: in addition to =, >, <, <>, !, !=, in: (#269)

2009-01-23 MickeM 
 + Added better support for numerical hit matching in the eventlog module. You can now use exact and detailed matching.
    You can now use the following syntax:
    CheckEventLog ... warn=ne:1 crit=eq:0 ...
    To generate a warning if the number of hits are != 1 and a critical if the number of hits are = 0.
    Other operators avalible are: =, >, <, <>, !, !=, eq:, ne:, gt:, lt:

2009-01-23 MickeM 
 * Cleaned up the checkProcState code and it is not a lot better.
   - Removed race conditions (crashes?) as well as improved perfoamnce and better error handling.
 + Added new option 16bit to checkProcState. When set checkProcState will enumerate all 16 bit processes found running under NTVDM.
 * Fixed NRPE version reported "incorrectly". (Version is now takedn from NSClient++)

2009-01-21 MickeM 
 + Added experimental 16 bit process support to checkProcState

2009-01-20 MickeM 
 * Fixed issue with CheckWMI when no filter was specified.

2009-01-17 MickeM
 + Added new command line option pdhlookup (to CheckSystem) to lookup index from names.
   Probably not usefull to anyone but me :) Usage: "nsclient++ -noboot CheckSystem pdhlookup Antal bindningsreferenser"
 * Fixed so PDH Collectors use the same exception as the rest of the PDH stuff (might give better errors when PDH breaks, but I doubt it)
 * removed debug output from -noboot
 + Added new command line pdhmatch option to use pattern matching on PDH queries
   Usage: nsclient++ -noboot CheckSystem pdhmatch \Process(*)\Antal trådar
 * Improved error reporting in the PDH subsystem.
 + Added new module A_DebugLogMetrics.dll which can be used to generate debug info.
   Enable the module and a file called process_info.csv will be created under %APP_DATA%/nsclient++/process_info.csv which contains metrics.
 * Fixed handle leak in CheckExternalProcess and NRPEListsner (executing commands).

2009-01-13 MickeM
 * Fixed issue with 64-bit installer (now installs under Program Files (and not x86)
 + Brand new build enviornment based upon boost build!!!
   Use batch file to build (release-build.bat or modify to make your own)
 * Modified /about so it now shows a lot of usefull(?) info.

2008-11-13 MickeM
 + Added truncate option to checkServiceState

2008-09-24 MickeM
 * Imroved the installer (now auto-updates the version when built)

2008-09-24 MickeM - 0.3.5
 * Fixed issue with CheckServiceState and CheckAll (it now works)
 + Added new check: CheckFile2 which has the same syntax as the event log filtering.
    Usage: CheckFile2 file=c:\test\*.txt filter=in filter+creation=<24h "syntax=%filename% was created %creation%" MinWarn=0 MinCrit=0

2008-09-18 MickeM - 0.3.4
 * Changed so "missing services" are treated as stopped.
    CheckServiceState missing=stopped ShowAll
	OK: missing: not found
 * Fixed issue with : in service name.
 + Added some "reasonable default cheks" under [External Alias] for the CheckExternalScripts.dll module. 

2008-09-17 MickeM - 0.3.4 RC-6
 * Added option [EventLog] lookup_names=0 to disable the evetlog name lookup (default is on)

2008-09-17 MickeM
 * Fixed issue on all filters so == takes the "usual" 2 equalsigns (old still works).
 * Added so tray icon can get "propper" name from core for "description".
 * Added lookup of "long" eventlog names (you can now use the alias used in the event viewer)

2008-09-16 MickeM - 0.3.4 RC-5
 * Fixed an issue with the session launcher

2008-09-15 MickeM
 * Fixed so NSCLient++ can load with "broken plugins" (before it printed an error and exited)
 + Added a very basic simple .net plugin (and a wrapper)

2008-09-14 MickeM - 0.3.4 RC-4
 * Fixed an issue with the session launcher
 * Fixed an issue with the uninstaller (should not "fail" when problems uninstalling)

2008-09-14 MickeM - 0.3.4 RC-4
 * Fixed issue with OS detection (again)
 * Fixed issue with plugin unloading (again)
 * Fixed issue with SSL socket not unloading properly
 * Fixed issue with "login" and "no session" (should work now I hope) (#222)
 * Changed so all projects build under "tmp" instead of under respecitve directory. (simpler to remove all "tmp" files now)

2008-09-12 MickeM
 * Thanks to everyone who listened in on my session at NETWAYS Nagios Konferenz 2008!

2008-09-09 MickeM - 0.3.4 RC-3
 * Improved error handling for the WMI checks.
 + CheckWMI: Added support for extracting numbers from strings 
 * Fixed performance data for "large float values" to be rendered without scientific notation. (#151)
 * Fixed issue with & and some commands via check_nt.
 * Fixed a crash on exit (which I added in Rc1).
 * Added 10 "bytes" the CPU buffer: (#174)
 + Added new option to [EventLog] section buffer_size to change the size of the buffer used when scanning the evenlotg (defaults to 64k).
 * Fixed error handling in CHeckEventLog so errors are repoorted properly (#184)

2008-09-08 MickeM - 0.3.4 RC-2
 * Fixed issue in windows 2008 with system tray (shared_session).
 * Fixed installer issue (should run (i hope) service installer on install now on 64 bit os)
 * Fixed issue with unloading plugins and log (causing "timeouts" when exiting some times)

2008-09-07 MickeM
 + Added sample powershell script as well as a workaround for making them run.
 * Fixed an issue making powershell scripts (and possibly others) not timeout properly.
 + Added upgrade support to the installer (still need to add support for keeping .ini file so be ware)

2008-09-06 MickeM
 * Improved error reporting in the eventlogchecker
 * *BREAKING CHANGE* filter=new is now the default so unless you use the new filtering you need to specify filter=old instead!
   I Recomend everyone to stop using the "old" filtering.

2008-09-04 MickeM
 * Fixed issues with new service stuff on NT4 and W2K (should work fine now)
 + Added some DebugOutput to service handling features so if you experience tropubel try using sysinternals DebugView too se logging before the agent startes.
 * Fixed a memory leak in the error formating code

2008-08-24 MickeM
 * Changed NSCA "general problem" error message to be more descriptive.
 * Fixed issue with CheckCPU not returning a valid performance unit (%) see issue #219 for details.

2008-08-16 MickeM
 * *WARNING* THIS IS VERY VERY UNSTABEL (possibly)
 * *WARNING* A lot of new untested code here so dont run in production enviornments :)
 + Added shared session so system tray can communicate with master
 + Added new system tray handlig (via TS so FUS should work with it)
 + Added new option [System] / shared_session=0 (or 1) to enable / disable the new shared memory framework (it is for now disabled by default)
   If you want to try this remember to change that option but also beware! it is dagerous and not finnished and and also there is as of now no security at all.

2008-08-09 MickeM
 + Added ChangeWindowMessageFilter so systray should maybe work on vista and beyond!

2008-07-28 MickeM
 * Improved the error handling for the check proc state.
 * Removed all (I think) asserts replacing them with exceptions (should I hope reduce crashes and instead leave some form of errors)

2008-07-25 MickeM
 + Built a garage at the summer house
 * cut down all the reeds and shrubbs at the summer house.

2008-07-03 MickeM
 * Fixed (again) issue with performance data and CheckDriveSize (when using "Min" bounds)
 + Added some more error messages for when counters are not found.
 * Fixed an issue with the new namespace option

2008-07-02 MickeM
 ! 0.3.3 Released (take 2)
 + Added new option alias to controll the name for performance counters when using checkfile use like so:
    checkfile alias=foo file=C:\boot.ini filter-written=>1000d syntax=gurka MaxCrit=1
 * Fixed issue with performance data and CheckDriveSize (when using "Min" bounds)
 ! 0.3.3 Released (take 1)
 * Fixed some issues (?) with the installer the w32 and x64 are now different components (GUIDs).

2008-07-02 MickeM
 + Fixed some issues (?) with the installer the w32 and x64 are now different components (GUIDs).

2008-07-01 MickeM
 + Added new option (namespace) to CheckWMI and CheckWMIValue use like so:
   CheckWMI namespace=root\\cimv2 MaxCrit=3 MinWarn=1 "Query:load=Select * from win32_Processor"

2008-06-30 MickeM
 * Fixed issue with CheckFile and performance data ( #156 )
 + Added option (InvalidStatus) to CheckCounter to allow other then UNKNOWN return state when counters are missing ( #167 ).
   *NOTICE* this is all reasons (so if the counter is missing or some such the same will happen not just when the instance is missing)
   Message will reflect reason.
 * Fixed issue in the arraybuffer (one of the plit functions had a problem with multiple chars of the same) ( #190 )

2008-06-25 MickeM
 * Fixed issue with CheckDriveSize and CheckAllOthers (#188)

2008-06-24 MickeM
 + Added new check (to CheckHelpers): CheckOK: Just return OK (anything passed along will be used as a message).
 + Added new check (to CheckHelpers): CheckWARNING: Just return WARN (anything passed along will be used as a message).
 + Added new check (to CheckHelpers): CheckCRITICAL: Just return CRIT (anything passed along will be used as a message).
 + Added new check (to CheckHelpers): CheckVersion: Just return the nagios version (along with OK status).
 * Better error messages in the check service thingy.

2008-06-18 MickeM
 * Fixed an issue in regards to reading the return packet in the in the NRPEClient (now it works).
   Before only the first 1024 bytes were used.

2008-06-15 MickeM
 * Applied patches from Jeff Goldschrafe <goldschr AT cshl.edu>
   + CheckDriveSize now uses "all drives" when no drive is specified.
   * Fixed misspellt Container

2008-06-14 MickeM
 * Fixed error message from external commands (better reporting now)

2008-05-14 MickeM
 * Fixed memoryleak in the service checker.
     I am really sorry I usualy write better code then this.

2008-04-03 MickeM
 * Moved COM init to "core" (from WMI module)
 + Added new Check command: CheckTaskSched Use like so:
     CheckTaskSched +filter-exit-code==1 ShowAll MaxWarn=1 MaxCrit=1

2008-03-21 MickeM
 + Added command line support for process checks
   New option: cmdLine will toggle so full command lines are used instead of just process names.
 + Added regular expression matching to process checks
   New option: match=regexp (match=strings is the default and "old" way)
 + Added substring matching to process checks
   New option: match=substr (match=strings is the default and "old" way)
   This is *NOT* case blind so might be hard to use, plan to add case blindness to it in the future.
 : Sample command: check_nt ... -v PROCSTATE -l cmdLine,match=regexp,.*exp.* -d SHOWALL
 * Ohh yeah... it is 2008 this year... not 2007, fixed a few entries in the  :)
 - BREAKING CHANGE! -- Removed TOOLHELPER API as PSAPI is simpler and toolhelp is really only useful on w9x (which I don't officially support)

2008-03-20 MickeM
 + Added host-lookupos for NSCA server (#149)
 + Added option (cache_hostname=1|0) to cache the NSCA host name (Ie. only lookup once)
 * Fixed service check: check_nt -v SERVICESTATE -l CheckAll so it works as advertised (#150)
 * Fixed issue with check_nt MEMUSE/CPULOAD/UPTIME if something is "broken" they will now return an error instead of "0". (#134)
   Added option debug_skip_data_collection to simulate this (just for kicks)

2008-03-18 MickeM
 * Added some more error messages to the NSCA module
 * Added support for arguments to LUA module.
   syntax: function debug (command, args) -- args is a table with all arguments

2008-03-11 MickeM
 ! 0.3.1 Released

2008-03-08 MickeM
 * Changed so log is now in Unicode format
   Hopefully this will make it simpler to diagnose PDH issues in "strange locales".
   If anyone hates this let me know and I will add an option to use "old ansi log".
 * Fixed so the console is logged as ANSI (properly) and all Unicode's are discarded.
   This means "strangeness" in Unicode and non-us-ascii chars on the console,
    so for details refer to the log-file which is proper Unicode.
 + Since log module is loaded "after" the client has booted I added a "hello" message that prints the current version
    (if you find this annoying let me know, I will make it optional :)
 * Fixed some issues in the registry handling

2008-03-06 MickeM
 * Fixed silly ordering bug with the <> syntax.

2008-03-05 MickeM
 + Added debug to new section [Eventlog], when enabled it will (log) what lines matched what, this is a pretty big performance overhead so don't run with this one.
 + Added syntax to new section [Eventlog] used as a shorthand for the syntax to use as "default" (when no syntax=... option is given)
 * Fixed an issue with eventlog and . matching.
 + Added shorthand ! for != in "all" numeric filters (eventlog)
 + Added <> (same as ! and !=) as NRPE breaks the use of ! (in "all" numeric filters (eventlog))
   Try using: filter-eventType=<>warning to remove everything that is not a warning
 * Fixed two spelling mistakes in the SysTray module.
 * Fixed 64-bit issues with installer
 * Fixed so installer uninstalls/installs the service
 
2008-02-26 MickeM
 + Added installer
 
2008-02-22 MickeM
 * Fixed issues in the NRPE module (now returns the correct status)
 + Added a lot of "error log" for when the packet size in NRPEListener is not correct 
    (might make it simpler to diagnose problems)

2008-02-20 MickeM
 + Added new module NRPEClient that can act as a NRPE client, might be useful for testing things and 
   eventually for relaying events.
   Usage: nsclient++ -noboot NRPEClient -H 192.168.0.1 -p 5666 -c check_something -a foo bar
   This is an early concept so don't expect much...
 * Fixed a bug in NSCA module (now it works again :)
 + Added a command wrapper for the NRPECLient module so now it can act as a check command.
   (No argument handling yet though), For a sample check out the [NRPE Client Handlers] section in NSC.ini

2008-02-19 MickeM
 + Fixed a buffer overflow in the NRPE socket handling.
 
2008-02-18 MickeM
 + Added proper output handling to process subsystem (now you can execute programs that return "much" data.
 + Added select support for SSL_write (now you can send "any amount of data" to the (SSL) socket.
   Since check_nrpe doesn't do this it wont work in that end, but still...

2008-02-16 MickeM
 + Re factored ExternalCommand handling so NRPE and new module does the same thing.

2008-02-14 MickeM
 + Added so commands starting in host_ (NSCA Handlers) are sent as host-commands
 * Fixed a copy constructor in NSCA Commands (now service checks are sent as service checks)

2008-02-13 MickeM
 + Added string_length to [Settings] as well (used internally) for all "injected" buffers.
 * Fixed issue with scripts result truncated after 1024 chars 
    (now they return "all" output and thus you can use the NRPE settings I added yesterday :)
 + Added hostname setting to [NSCA] section (must have been  when I did not add it before)
 + Added to NSCA truncates output when to long.

2008-02-12 MickeM
 + Added new option for the [NRPE] section string_length which is the length of the NRPE strings 
   (notice you need to recompile the check_nrpe to match this value)
 * Improved exception handling in the PDH collector (hopefully less deadlocks)

2008-02-11 MickeM
 + Added encryption support for NSCA module (about half of the algorithms are available, 
     if someone wants to use one not available let me know, and I will try to add it)

2008-02-09 MickeM
 + New module CheckExternalScripts to handle 1, external script (similar to the old NRPE but in its own module)
   - Can Check batch/vbs/programs/*
   - Works with NSCA module (if you don't want to have NRPE at the same time)
   - Simpler syntax (discarded old and added new section for alias)
   - Started to add "sample alias" to ease initial setup and give some nice ideas (please provide me with feedback on them)

2008-02-08 MickeM
 + Added some more default catch handlers (on the "core" side of plugin-calls).

2008-02-07 MickeM
 + Added default catch handlers to all wrapped plug in calls.

2008-02-05 MickeM
 * Fixed issue with checkEventLog (sometimes you got the wrong message back)

2008-02-04 MickeM
 *** Happy Birthday bogi!! :)
 * Fixed issues with performance counter rendering (mainly checkDisk)

2008-02-03 MickeM
 + Added encryption subsystem to NSCA module (still no mcrypt support, but at least you have "xor" and passwords)
 + Added API for scripts to register commands
 + Added command descriptions (for some modules)
 * Fixed issue in NRPE that displayed a console window when running commands
 * New improved "inject" dialog from the system tray
   Lists available commands, and shows command descriptions and a lot of other improvements.
 + Added an internal log windows that displays log in real-time.
 + Fixed some issues with the dialog procs (should work smoother now, especially Termination)

2008-02-02 MickeM
 * Might have fixed the "missing eventlog messages" problem.
 + Added %count% parameter to syntax which (when used with unique) will display the number of hits for each message displayed.

2008-01-27 MickeM
 * Fixed a memory-leak in format_time
 * Fixed so time/date is displayed in "local time" (not UTC) for the eventlog check
 + Added %message% to eventlog check. Will display the "proper formated eventlog message" as in the eventlog viewer.
   For this to work you need to have the descriptions flag set
   In short: /nrpe -H 192.168.0.147 -c checkEventLog -a truncate=1024 "syntax=%generated%: %message%" descriptions=true file=System MaxWarn=1 MaxCrit=1 filter+eventType==error filter+generated=\<12h filter=new filter=all filter=in
 + Added option "unique" to CheckEventLog If this is present only unique errors will be returned.
   The uniqueness is defined by event-log, event-source, event-id and event-category.

2007-12-16 MickeM
 + A lot of new features in the LUA module only "arguments" missing (as well as exposing more of the API)
 * Changed some exceptions that were thrown wrong

2007-12-11 MickeM
 + Added support for index-lookups of PDH counters (hopefully *all* locale problems are now fixed (yeah right))

2007-12-10 MickeM
 + Added initial draft for LUA module

2007-12-09 MickeM
 + Added a check if the service is started when running with /test so you get a warning
 + Improved the socket thread with:
    * a default-catch
    * If the socket fails to start we still wait for it to shut down (no error message)
 + Added first version of the NSCA agent (NSCAgent.dll)
   (no encryption support as of yet, but will come)

2007-12-04 MickeM
 ! 0.3.0 Released

2007-12-01 MickeM
 * Fixed issue with date formating in FILEAGE

2007-11-29 MickeM
 * Fixed issue with date formating in FILEAGE

2007-11-28 MickeM
 ! 0.3.0 RC-1
 * Fixed some UNICODE issues with process-listings
 + Added an error message if the "detected" process enumeration method is not available.
 + Fixed some more Unicode issues Password encrypt/decrypt: #107
 * Fixed Unicode issues with "external programs" #109
 * Fixed so default string for check_nt:s FILEAGE command is "delta" is 5 minutes ago (and not absolute ie. 1970...), Issue #39
 + added support for  <date strings> to check_nt:s FILEAGE command, Issue #39
    append: .<date string> if you want to use a "custom date" like so: ... -v FILEAGE -l c:\\windows,Date: %Y-%m-%d %H:%M:%S" -w 5 -c 6 ...
    Only the above listed %<char> works, and default to 0 so might not be to pretty but works...

2007-11-26 MickeM
 + Fixed a socket issue (erroneously reported "Could not read NSClient packet from socket :(")
 * More 2k5 build tweaks

2007-11-23 MickeM
 * Converted to Unicode (damn sometimes I **HATE** C++)
 + Added support for escaping " on the /test syntax so now you can do: CheckWMI MaxCrit=3 "MinWarn=1" "Query:load=Select * from win32_Processor"

2007-11-22 MickeM
 * Fixed so the "default path" is correct even when running as a service (issue: #96)

2007-11-21 MickeM
 * Fixed process counter so checkProcState  now return the *correct* number (previously it was correct-1)
 * Fixed some missing exceptions that were not caught
 + Added "AliasCol" option to CheckWMIValue to allow a column to be used as "alias" for a result set:
     CheckWMIValue -a "Query=select Caption, ThreadCount from Win32_Process" MaxWarn=50 MaxCrit=100 Check:threads=ThreadCount AliasCol=Caption
    will give you: "System threads: 98 > warning, svchost.exe threads: 87 > warning"
 - Removed  from SVN (as it is old and outdated and no longer used)

2007-11-20 MickeM
 + Added new option to CheckSystem to override detected language (force_language=0x0014)

2007-11-19 MickeM
 * Fixed a minor issue in reading registry keys
 + Added -noboot option to startup used for running command line utilities without booting the client
   "nsclient++ -noboot RemoteConfigruation ini2reg" for instance
 + Added fall back to try <module> and <module>.dll if the module was not loaded (when running command lines)
 * Migrated 2008 project files to new name and back ported to 2005 project files.

2007-11-16 MickeM
 * Fixed an NRPE issue I added when I improved the sockets_timeout (now SSL works as well :).
 + Added sample VBS script and definitions

2007-11-15 MickeM
 * Improved error message when external NRPE command failles.

2007-11-14 MickeM
 + Added multi-line output support ( issue #91 )
 * Improved error handling for external commands
 * Fixed an issue with NRPE/NSClient socket-reading (introduced by the socket_timeout)
 + Added an English fall back if "local" language PDH counters fail.

2007-11-12 MickeM
 + Added option to configure socket_timeouts (default is now 30 seconds) should (I hope) fix issue #85

2007-11-11 MickeM
 + Added option to configure the behavior of CheckService CheckAll (#64)

2007-11-08 MickeM
 + Added CheckWMIValue to check result-values from a WMI Query
 * Changed so performance values are "collapsed" i.e. 75362115584 = 70.0G (#89)
    If anyone don't want this let me know and I will make an option for it.

2007-11-06 MickeM
 + Added CLI interface to CheckWMI to check queries

2007-11-04 MickeM
 * Rewritten WMI handling as well as checks so things should be more useful now (cf. the wiki page for details)

2007-10-29 MickeM
 * Restructured build and include to work from CLI
 + Started to add makefiles to build from CLI
 + Added Finnish counters (#98)
 * Fixed performance counter issue with check_nt (#99)
 
2007-10-06 MickeM
 + Added auto-upda-te of versions and dates on build to make versions better updated.
 + Fixed x64 build and cleanup a bit.

2007-09-15 MickeM
 + Added better error messages (now return codes are displayed as text). Not implemented all over yet but the infrastructure is there.

2007-09-11 MickeM
 + Added Dutch performance counters to counters.defs
 + Added Spanish performance counters to counters.defs
 + Added #69 [includes] directive to INI-file to include other files
 * Fixed #75 (spelling issue)

2007-06-23 MickeM
 * Might have fixed #53 I was not able to get the problem locally but I have fixed the problem ias at op5 discovered at least...
 * Fixed the "check memory" issues for real this time.
 * Fixed problem with : in counter names #50 (anything starts with \ is considered a counter so if you use aliases with \ this will break things for you.

2007-06-20 MickeM
 * Fixed #24 crash in NSClient++.exe CheckSystem listpdh | debugpdh
 * Fixed #62 Problems with CheckServiceState and services with spaces.

2007-03-06 MickeM
 ! 0.2.7 released

2007-03-05 MickeM
 * Fixed -v FILEAGE check_nt (NSClient) check.
 * Added license agreement header to all files

2007-03-04 MickeM
 + Added script_dir option to NRPE section as well as some sample scripts in the scripts/
   subdirectory. The script_dir will use all files in this directory as scripts for NRPE
 + Added Japanese counters to counters.defs from patch (thanx!!!)

2007-02-25 MickeM
 + Added possibility to check many memory checks in one go, just stack type options.
     type=paged type=physical etc...
 * Fixed a performance check bug in the last nightly.
 * Fixed a potential crash when a malformed check-file-age command was issued.
 + Added support for more then and NSClient command
 + Added net mask support to allowed_hosts (try with 192.168.0.1/24 and such)
 
2007-02-22 MickeM
 + Added debug output to see if the socket is bound and/or has shutdown.
 * Fixed a potential bug in the thread manager.
 + Added configuration option for suppressing performance data to the NRPE section.
   Set performance_data=0 to stop sending performance data to nagios
 + New (better?) (simpler?) event log checking
 + Added option to most commands (ignore-perf-data) to suppress performance data
 + Added option CheckAll for checking all auto-start services to checkServiceState.
   Also an exclude=<service> to exclude checking that.
 * Fixed return syntax for PROCSTATE nsclient

2007-02-21 MickeM
 * Fixed "broken password check" (again) in NSClient listener (this time it is correct! :)

2006-12-02 MickeM
 + Managed to build so it works on NT 4.0 (SP6a) and W2K3
 * Fixed "broken password check" in NSClient listener

2006-11-18 MickeM
 + Added support for empty NRPE checking (i.e.. chec_nrpe without a -c argument)
 * Added error message when detected language is missing from counters.defs
 + Added Swedish locale to counters.defs (yes, I switched to Swedish XP on my computer :)
 * Fixed : (and possibly other problems) in counters when checking from check_nt (via NSCLient protocol)
 + Added CheckAllExcept to CheckDrive to check all except the specified drives.
 * Fixed a display error in the various size functions (1000-1024 byte was displayed incorrectly)

2006-10-05 MickeM
 * Yayyy!!! (first fix in a looong while :)
 * Fixed a W2k3 "bug" (actually just an incorrect error) but the:
   "e .\PDHCollector.cpp(130) Failed to query performance counters..." is no more...
 + Added option to NRPE/NSClient section to not-cache host names (for dyndns etc.)
   NOTICE this is "not safe" really in so far as someone might hi-jack your DNS and quickly gain 
   access to your nagios box (probably only a theoretical problem but hey! :)
   NOTICE this is "slow" since all hosts in the list are "looked up" each time you get a NRPE/NSClient 
   request it will be "slow" but I think it is not that much of a problem really.
   NOTICE I don't have the possibility to test this so feel free to report if it works and if it doesn't.
   Set cache_allowed_hosts=0 to disable host cache

2006-04-04 MickeM
 * Fixed a few more bugs to the INI/REG readers

2006-04-02 MickeM
 * Could all magicians stop trying to kill me? 
   *Please* i don't like to die!

2006-03-31 MickeM
 * Damn necromancers! stop 0wning my ass all the time!
 
2006-03-29 MickeM
 + Added API for saving/reading settings
 
2006-03-28 MickeM
 + Added REG/INI parsers
 * *NOTICE* You need to add an option (use_file=1) to your nsc.ini file or new builds wont work.

2006-03-25 MickeM
 * Oblivion f*cking roxx!

2006-03-02 MickeM
 * Fixed bug in INI-file reader (memory leak)

2006-03-01 MickeM
 * Fixed bug in CheckFile (now dates work correctly)

2006-02-26 MickeM
 + Added syntax option to CheckFile (%filename%, %creation%, %access%, %write%, %size%).

2006-02-25 MickeM
 * Fixed Sections problem (now sections can be any size)
 + Added bind_to_address option to both NRPE and NSClient section in the INI file.
   Allows you to bind the listener to a specific IP address (only dotted number not host name).
   This might break things as I had to do some internal rewrite of the Socket classes so be careful :)
 * Disabled default-debug logging (as things are fairly stable, you can still enable it by using debug=1 in the NSC:ini file)
 * "Fixed" socket backlog to use "max responsible value" as opposed to "10" if no value is specified.
 + Added option socket_back_log to both NRPE and NSClient section that allows you to tweak the "back-log" of incoming connections to keep.
   This is an advanced setting and should not be used. If you get "connection refused" when running many client this might be something you want to tweak though.
   And if you then start getting "Socket timeout" you might wanna tweak the timeout value as well because larger value here means it takes "longer" to process a socket.
 - I have looked into the event log problem and dates seem to work here so if anyone still have problems (use the syntax option to debug) let me know.
 * Moved listpdh and debugpdh into the CheckSystem module
 * Removed PDH dependencies from "core exe" means you can run NSClient++ without PDH (though you cant use the CheckSystem module)
 
2006-02-2? MickeM
 + Added new Interface for Modules (NSCommandLineExec that allows modules to execute things give from command line.
   Syntax is NSClient++ <module name> <command> [arguments] and if a module doesn't support this it is simply ignored.
 + Added new install/uninstall command to SystemTray module:
   NSClient++.exe SystemTray install 
   NSClient++.exe SystemTray uninstall 
   That will install/uninstall the system tray module this sets the "Allow Service to Interact with Desktop" flag for the service.
 * Removed the "Allow Service to Interact with Desktop" flag from the /install option so that it no longer defaults to on (see commands to set this above).
 * Fixed so checkProcess isn't case sensitive.
 * Added (not finished) syntax option to event log checker to format the outputted data

2006-02-12 MickeM
 + Added support for host name resolve to allowed_hosts

2006-02-08 MickeM
 ! Fixed filter-eventID in EventLog module (now works for all IDs regardless of severity state)
 + Added new filters to EventLog (filter-severity that can filter based on event severity success, error, warning, informational)

2006-02-07 MickeM
 + Added new filter option to eventlog filter-eventID
 + Added new operator to all numeric filters in:number,number,... etc. (for instance filter-eventID=in:123,456,789 to check for lists.

2006-02-05 MickeM
 + Added CheckFile check command
   This new command (in development) will allow various file checks such as age, size, date, etc on single or multiple files.
 + Added FILEAGE support to NSClient
 + Started to convert the web page to WIKI
 
2006-01-21 MickeM
 + Added WMI Check module (early alpha)
   This is an extremely early alpha more to see if there is an interest and how to progress with it.
   To use the WMI module enable the WMICheck.dll (nsc.ini) and then run the following check:
   CheckWMI MaxWarn=10 MaxCrit=15 "Query:load=Select LoadPercentage from win32_Processor"
   The Max* are as every other check and sets limits. 
   The Query works similarly to other check commands i.e.. Query:<name>=<WMI query>
   So any other WMI query should work (notice this is experimental and not stable and has virtually 
   no error handling so it is likely to crash nsclient if you ask anything "non working".)
   I would *really* *really* like to get feedback on how to expand this concept to work better so feel free to come with feedback.
  * Fixed NT4 /install (should work now!)

2006-01-02 MickeM
 * Fixed ChangeServiceConfig2 on NT4
 + Added support for more then 4GB memory (8GB?)
   Since I don't have this much memory this needs to be verified...
 * Fixed syntax of performance data

2005-09-24 MickeM
 * Fixed memory size bug (free and used were swapped)

2005-09-20 MickeM
 + Added option to debug all PDH counters /debugpdh

2005-09-17 MickeM
 + Added support for checking service by display name

2005-09-03 MickeM
 * First off, sorry for lack of updates, but was on vacation :)
 + Added ShowAll=long to CPULoad
 + Added several new types to checkMem (type=paged, type=physical, type=page, type=virtual)

2005-07-31 MickeM
 + /install now sets the service to autostart
 * Did some cleanup of minor code sections
 * (done before but not reported i think) /listpdh option added to list all PDH counters (nsclient++ /listpdh)
 + Added service description
 * Event log reworked (again) this time I hope it is better (and even useful, but syntax has changed)

2005-07-26 MickeM
 + Added support for ShowAll=long (to show long and short info, only applies to some areas, but available everywhere)
 + Extended Drive and memory check syntax to facilitate both Free and Used space checks: MaxWarnFree / MaxWarnUsed etc)

2005-07-19 MickeM
 * Changed thread API to use _creatthreadex as opposed to _creatthread (works better now!)
 * Fixed UNKNOWN return code (was 4 should have been 3)

2005-07-16 MickeM
 * Fixed drive checks from NSClient

2005-07-11 MickeM
 * *ALOT* of bug fixes and enhancements all checking code has been centralized and rewritten also my internal check scripts 
   have been extended to check a lot more things.
   *NOTICE* that EventLog has not been upgraded yet neither has the documentation.
 + Added MaxWarnCount / MinWarnCount to checkProcState to check number of processes running

2005-06-09 MickeM
 * Escapes " in NRPE commands in the NSC.ini

2005-06-05 MickeM
 * Created configuration interface (not released yet)

2005-06-03 MickeM
 * Created interactive installer (not released yet)

2005-06-02 MickeM
 * CheckEventLog reworked...

2005-06-01 MickeM
 * CheckSystem auto detects windows version and language.

2005-05-29 MickeM
 * Fixed PROCSTATE and SERVICESTATE return state.
 + Added support for individual size in CheckDriveSize and CheckFileSize (size has to be specified before a drive/path)
 * Fixed performance data for drives (and possibly other places)

2005-05-23 MickeM
 + Added obfuscated password support
 + Added some more debug info on commands (return code, and input args)
 + Added some more comments to the NSC.ini
 + Added central password "override"
 + Added central "host override"
 + Fixed bug with external commands always getting WARNING state

2005-05-22 MickeM
 + Added debug output for command
 + Added timestamps for log-to-file (date_mask to configure format)
 + Added support for "no password" with check_nt
 + Added log of bad password on NSClient requests.
 * Some threading issues fixed (I hate threading :)

2005-05-19 MickeM
 * Verified NT4 compatibility

2005-05-18 MickeM
 * Fixed bug in NSC.ini (section title for Check System was wrong)
 + Added multitasking for plug-ins (now two plug-ins can handle requests simultaneously)
 * Fixed some minor issues here and there

2005-05-15 MickeM
 + Added NRPE support for checkCounter
 + Updated documentation
 * Make check commands ignore case
 + Added CheckHelpers module to alter the result of various check and similar things 

2005-05-14 MickeM
 + Added support for Volumes (CheckDisk)
 + Added support for checking all drives of a certain kind
 + Added support for altering filter (makes it possible to check removable drives)
 + Created web page and better documentation

2005-04-20 MickeM
 + Added multitasking to socket listener (it can now handle multiple connections)
 * Fixed bug in NSClientListener now "seqv" in check_nt shouldn't happen.
 + Added COUNTER support to NSClient and CheckSystem

2005-04-19 MickeM
 + Added SSL support
 + Added a lot of new options
 + Added documentation
 * Renamed and restructured NSCLientCompat to CheckSystem
 * *ALOT* of fixes all over
 : We are now starting to get to something that is "stable"
 : This means that soon you might actually be able to use this.
 
2005-03-28 MickeM
 * Changed the Thread class a bit (mutex -> signal, and CreatThread does not return the instance)
 * Moved settings "keys" fro NRPE to config.h
 * Changed build options (added Distribution) which builds a zip file under ./dist (requires 7z installed)
 * Minor tweaks to error/debug logging and small fixes "here and there"

2005-03-26 MickeM
 + NRPE Support (very basic, no encryption, and nothing fancy)
 * Socket classes rewritten
 + Added NSCModuleHelper::getSettingsSection to the API

2005-03-22 MickeM
 * Fixed NSClientListener return codes for basic commands
 * Extracted arrayBuffer code into new files under /include
 * Minor tweaks in the API (fixed minor issues)
 + Added some basic "tests" to a few commands (getToken, and arrayBuffer related)

2005-03-21 MickeM
 * Fixed BUG in inject command (now things should "work" again, but far from stable)
 + Added NRPE return code
 * Fixed some return states to NSClientListener (not verified yet, but soon they will be back in order :)

2005-03-20 MickeM
 * Fundamental API changes (due to NRPE compatibility)
   - HandleCommand has changed
   - Inject has changed
   - Most API calls have new "return codes" (typedef:ed INT to allow for return code compiler checks)
   - A lot of the old return codes have changed
 + Preliminary NRPE support (can parse and execute incoming requests, cant return data yet, and no encryption)
 + New SimpleSocket in include/ will be used as base class for Listeners
 * A lot of rewrite to the NSC API

2005-03-19 MickeM
 * Re factored out NSCLient Listener as a separate module
 + Added initial NRPE listener module (not yet implemented only a shell)
 * Changed Module API (Inject function has new syntax)
 + Added some tokenizer function to charEx
 + Added new wrapper function to inject Command
 * Minor changes in relation to refactor work

2005-03-01 MickeM
 * Improved thread safety in Core
 + Added exception handling and logging in PDH code
 * Various fixes all over the place
 + New module for check size of files/directories
 * Changed build to Dynamic link
 * Added regular expression support for EventLog checker

2005-02-22 MickeM
 + Added documentation

2005-02-17 MickeM
 * NSClient issues fixed
 * System Tray issues fixed

2005-02-14 MickeM
 * Initial SourceForge release